[21.04 FEAT] KVM enablement for enhanced hardware diagnose data of guest kernel - kernel part

Bug #1853313 reported by bugproxy
14
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Ubuntu on IBM z Systems
Fix Released
Medium
Frank Heimes
linux (Ubuntu)
Fix Released
Undecided
Skipper Bug Screeners

Bug Description

KVM enablement for enhanced hardware diagnose data of guest kernel

bugproxy (bugproxy)
tags: added: architecture-s39064 bugnameltc-182248 severity-high targetmilestone-inin2004
Changed in ubuntu:
assignee: nobody → Skipper Bug Screeners (skipper-screen-team)
affects: ubuntu → linux (Ubuntu)
Revision history for this message
Frank Heimes (fheimes) wrote :

Please specify the planned target kernel this is going to become upstream accepted.
Changing to Incomplete until available.

Changed in linux (Ubuntu):
status: New → Incomplete
Changed in ubuntu-z-systems:
status: New → Incomplete
importance: Undecided → Medium
assignee: nobody → Frank Heimes (frank-heimes)
Revision history for this message
bugproxy (bugproxy) wrote : Comment bridged from LTC Bugzilla

------- Comment From <email address hidden> 2019-11-22 08:06 EDT-------
Planned Target : kernel 5.5

Revision history for this message
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2020-01-21 11:04 EDT-------
Following git-commits need to be applied:

For DIAG 0x318 instruction execution
commit 4ad78b8651aacf26b3ab6d1e784952eb70469c43
s390/setup: set control program code via diag 318

The s390x diagnose 318 instruction sets the control program name code (CPNC)
and control program version code (CPVC) to provide useful information
regarding the OS during debugging. The CPNC is explicitly set to 4 to
indicate a Linux/KVM environment.

The CPVC is a 7-byte value containing:

- 3-byte Linux version code, currently set to 0
- 3-byte unique value, currently set to 0
- 1-byte trailing null

Additionally, there is the HPID component to this item. The former git-commit I provided (for DIAG 0x318) is the more important piece, however if we can include this patch as well that would be great (if it isn't already included):

commit 67d49d52ae502eaea8858fbcb97e3c2891f78da9

KVM: s390: set host program identifier

A host program identifier (HPID) provides information regarding the
underlying host environment. A level-2 (VM) guest will have an HPID
denoting Linux/KVM, which is set during VCPU setup. A level-3 (VM on a
VM) and beyond guest will have an HPID denoting KVM vSIE, which is set
for all shadow control blocks, overriding the original value of the
HPID.

Frank Heimes (fheimes)
Changed in linux (Ubuntu):
status: Incomplete → Triaged
Changed in ubuntu-z-systems:
status: Incomplete → Triaged
Revision history for this message
Frank Heimes (fheimes) wrote : Re: [20.04 FEAT] KVM enablement for enhanced hardware diagnose data of guest kernel - kernel part

I've looked-up the above git commits and found that they are already in (since quite some time - 2018):

# linux-next:

$ git log --oneline --grep "s390/setup: set control program code via diag 318"
4ad78b8 s390/setup: set control program code via diag 318
$ git tag --contains 4ad78b8
next-20200129
v5.1
...
v5.5

$ git log --oneline --grep "KVM: s390: set host program identifier"
67d49d5 KVM: s390: set host program identifier
$ git tag --contains 67d49d5
next-20200129
v4.20
...
v5.5

And with that they are already in focal, too - just to double check:

# focal-master:

$ git log --oneline --grep "s390/setup: set control program code via diag 318"
4ad78b8 s390/setup: set control program code via diag 318
$ git tag --contains 4ad78b8
Ubuntu-5.4-5.4.0-10.13
Ubuntu-5.4-5.4.0-11.14
Ubuntu-5.4-5.4.0-12.15
Ubuntu-5.4.0-8.11
Ubuntu-5.4.0-9.12

$ git log --oneline --grep "KVM: s390: set host program identifier"
67d49d5 KVM: s390: set host program identifier
$ git tag --contains 67d49d5
Ubuntu-5.4-5.4.0-10.13
Ubuntu-5.4-5.4.0-11.14
Ubuntu-5.4-5.4.0-12.15
Ubuntu-5.4.0-8.11
Ubuntu-5.4.0-9.12
v5.0

The question is now why these got requested (again) for focal?
Or are these just not the correct commit IDs?

Revision history for this message
bugproxy (bugproxy) wrote : Comment bridged from LTC Bugzilla

------- Comment From <email address hidden> 2020-01-30 10:31 EDT-------
@CAN, you are right. These git-commits are related to another feature, which is already available.

Correct git-commits will be provided once available for integration into 20.04.

Sorry for this misleading information.....

Revision history for this message
Frank Heimes (fheimes) wrote : Re: [20.04 FEAT] KVM enablement for enhanced hardware diagnose data of guest kernel - kernel part

Okay, np, I'll just change the status to Incomplete again until the IDs got shared.

Changed in linux (Ubuntu):
status: Triaged → Incomplete
Changed in ubuntu-z-systems:
status: Triaged → Incomplete
summary: - [20.04 FEAT] KVM enablement for enhanced hardware diagnose data of guest
+ [20.10 FEAT] KVM enablement for enhanced hardware diagnose data of guest
kernel - kernel part
Revision history for this message
bugproxy (bugproxy) wrote : Comment bridged from LTC Bugzilla

------- Comment From <email address hidden> 2020-02-04 02:39 EDT-------
Feature will not make it in time for Ubuntu 20.04-> moved to 20.10

tags: added: targetmilestone-inin2010
removed: targetmilestone-inin2004
summary: - [20.10 FEAT] KVM enablement for enhanced hardware diagnose data of guest
+ [21.04 FEAT] KVM enablement for enhanced hardware diagnose data of guest
kernel - kernel part
Revision history for this message
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2020-08-27 02:23 EDT-------
Feature request moved to 21.04. Will not make it in time for 20.10

tags: added: targetmilestone-inin2104
removed: targetmilestone-inin2010
Revision history for this message
Frank Heimes (fheimes) wrote :

Code is in 5.9 - hence updating status to Fix Committed, since we have 5.10 in proposed.

Changed in linux (Ubuntu):
status: Incomplete → Fix Committed
Changed in ubuntu-z-systems:
status: Incomplete → Fix Committed
Revision history for this message
Frank Heimes (fheimes) wrote :

Now that kernel 5.10 landed in hirsute's release pocket:
linux-generic | 5.10.0.14.16 | hirsute
this ticket is done, hence I'm updating the status to 'Fix Released".

Frank Heimes (fheimes)
Changed in linux (Ubuntu):
status: Fix Committed → Fix Released
Changed in ubuntu-z-systems:
status: Fix Committed → Fix Released
Revision history for this message
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2021-02-22 03:36 EDT-------
IBM Bugzilla status->closed, Fix Released with hirsuite

Frank Heimes (fheimes)
information type: Private → Public
To post a comment you must log in.
This report contains Public information  
Everyone can see this information.

Other bug subscribers